$(function () {
  var getSelectedRowData = function (tr) {
    var parent = tr.parents(".ldapGroups");
    return {
      group: tr.find("[name=newLgrGroup]").val(),
      role: tr.find("select[name=newLgrRole]").val(),
      domainId: parent.data("domain-id")
    };
  };

  $(".groupForm").live("submit", function () {
    var parent = $(this).parents(".ldapGroups");
    $.post(LS.routes.saveGroup, getSelectedRowData($(this).find("tr.addRow")), function (html) {
      $("#collapse" + parent.data("domain-id")).find(".ldapGroups").html(html);
    });
    return false;
  });

  $("[name=lgrRole]").live('change', function () {
    $.post($(this).data("url"), {role: $(this).val()});
  });


  $(".deleteGroup").live('click', function () {
    var question = "Are you sure you want to delete this LDAP Domain group mapping?";
    var url = $(this).data("url");
    var domainId = $(this).data("domain-id");
    var deleteAction = function () {
      $.post(url, function (html) {
        $("#collapse" + domainId).find(".ldapGroups").html(html);
      });
      $("#commonModal").modal("hide");
    };
    removeConfirm(question, $.proxy(deleteAction, this));
    return false;
  });

  $("#testConnection").click(function () {
    LS.common.testConnection($(this));
  });

  $(document).click(function () {
    $("#testConnection, .domainUsers").popover('destroy');
  });

  $(".domainUsers").click(function () {
    var button = $(this);
    var id = button.data("id");
    var usersList = $("#domainUsersList_" + id);

    var body = usersList.find("> .content");
    button.popover({
      html: true,
      trigger: 'manual',
      placement: 'bottom',
      title: usersList.find("> h1").html(),
      content: body.html()
    });
    button.popover('show');
    return false;
  });
});
